#include <unistd.h>
#include <stdio.h>
#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "hex.h"

#ifndef O_BINARY
#define O_BINARY 0
#endif

int main(int argc, char *argv[])
{
	struct stat dummy;
	int fd, size, address;
	char dst_file[PATH_MAX];
	unsigned char buf[0x8000];

	if(argc == 1) {
		fprintf(stderr, "S-OS to Intel Hex Converter\nUsage: %s [S-OS file] or %s [S-OS file] [Intel HEX file]\n", argv[0], argv[0]);
		return 1;
	}
	if(argc == 2)
		sprintf(dst_file, "%s.hex", argv[1]);
	else
		strcpy(dst_file, argv[2]);
	if(stat(dst_file, &dummy) == 0) {
		fprintf(stderr, "%s exists.\n", dst_file);
		return 1;
	}

	if((fd = open(argv[1], O_RDONLY | O_BINARY)) < 0) {
		fprintf(stderr, "Cannot open %s.\n", argv[1]);
		return 1;
	}
	size = read(fd, buf, sizeof(buf));
	if (size <= 13 || memcmp(buf, "_SOS", 4) != 0) {
		fprintf(stderr, "%s is not S-OS file.\n", argv[1]);
		return 1;
	}

	sscanf(buf + 8, "%4x", &address);
	if(writeHexAbs(dst_file, buf + 0x12, address, size - 0x12) <= 0) {
		fprintf(stderr, "Fail to write %s.\n", dst_file);
		return 1;
	}

	close(fd);
	return 0;
}

/* eof */
